#!/usr/bin/perl
#

use FileHandle;
use File::Copy;

my $mods = new FileHandle();
open( $mods, ">pdk_uxmon.pm" ) || die "cannot create file pdk_uxmon.pm: $!";
print $mods "use pdkmods_uxmon;\n";
emit_modules( $mods, "bin/Monitor", "Monitor::" );
emit_modules( $mods, "uxmon/Requester", "Requester::" );
opendir( DIR, "uxmon/Config" );
foreach my $file (readdir( DIR )) {
    next if( $file =~ /^\./ );
    print $mods "require \"$file\";\n";
}
closedir DIR;
close $mods;

open( $mods, ">pdk_bsmon.pm" ) || die "cannot create file pdk_bsmon.pm: $!";
#print $mods "use pkdmods_bsmon;\n";
emit_modules( $mods, "bin/Statusmon", "Statusmon::" );
close $mods;

foreach my $bin ( 
    {
        "exe" => "uxmon.exe",
	"main" => "uxmon/uxmon",
	"mods" => "pdk_uxmon",
    }
) {

    copy( $bin->{'main'}, "main.pl" ) 
      or die "could not copy $bin->{'main'}";
    chmod( 0700, "main.pl" );
    my @cmd = ( "perlsvc", "--lib", ".;bin;uxmon;uxmon/Config", "--exe",  $bin->{'exe'},
                "--add", "main.pl", "--force", "--verbose",
		"--add", "pdkmods" );
    push( @cmd, "--add", $bin->{"mods"} ) if( $bin->{"mods"} );
    push( @cmd, "bin/perlsvc.pl" );
    system( @cmd ) || print STDERR "compilation failed";
    print "command was: " . join( " ", @cmd ) . "\n";
}



sub emit_modules {
    my( $fh, $path, $prefix ) = @_;

    opendir( _DIR, "$path" ) || return 0;
    my @subs = readdir( _DIR );
    closedir( _DIR );
    foreach my $file (@subs) {
        next if( $file =~ /^\./ );
	if( -d "$path/$file" ) {
	    emit_modules( $fh, "$path/$file", "$prefix$file::" );
	}
	elsif( $file =~ /^(.*)\.pm$/ ) {
	    print $fh "use $prefix$1;\n";
	}
    }
}
